function y = BSIV(v,MarketPrice,S,K,r,q,T,PutCall)

% Inline function for the Black Scholes call
C = inline('s*exp(-q*T)*normcdf((log(s/K) + (r-q+v^2/2)*T)/v/sqrt(T)) - K*exp(-r*T)*normcdf((log(s/K) + (r-q+v^2/2)*T)/v/sqrt(T) - v*sqrt(T))',...
	's','K','r','q','v','T');

% Inline function for the Black Scholes put
P = inline('K*exp(-r*T)*normcdf(-(log(s/K) + (r-q+v^2/2)*T)/v/sqrt(T) + v*sqrt(T)) - s*exp(-q*T)*normcdf(-(log(s/K) + (r-q+v^2/2)*T)/v/sqrt(T))',...
	's','K','r','q','v','T');

if strcmp(PutCall,'C')
	y = (MarketPrice - C(S,K,r,q,v,T))^2;
else
	y = (MarketPrice - P(S,K,r,q,v,T))^2;
end

if v<0
	y = 1e100;
end

	

	